<?php
declare(strict_types=1);

namespace Inti\Elementor\Plugin\Factory;

use Inti\Elementor\Plugin\RegisterWidgets;
use Inti\Elementor\Widget\WidgetManager;
use Inti\Wp\Plugin\PluginInterface;
use Psr\Container\ContainerInterface;

/**
 * Class RegisterWidgetsFactory
 *
 * @package Inti\Elementor\Plugin\Factory
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-elementor
 */
final class RegisterWidgetsFactory
{
    public function __invoke(ContainerInterface $container): PluginInterface
    {
        return new RegisterWidgets(
            $container->get(WidgetManager::class)
        );
    }
}
