<?php
declare(strict_types=1);

namespace Inti\Elementor\Plugin;

use Elementor\Elements_Manager;
use Inti\Wp\Plugin\PluginInterface;

/**
 * Class RegisterCategory
 *
 * @package Inti\Elementor\Plugin
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-elementor
 */
final class RegisterCategories implements PluginInterface
{
    /** @var array<string, array> */
    private array $categories;

    public function run(?array $options = null): void
    {
        $this->categories = $options ?? [];

        if (!empty($this->categories)) {
            add_action('elementor/elements/categories_registered', [$this, 'categories_registered']);
        }
    }

    public function categories_registered(Elements_Manager $manager): void
    {
        foreach ($this->categories as $name => $properties) {
            $manager->add_category($name, $properties);
        }
    }
}
