<?php
declare(strict_types=1);

namespace Inti\Elementor\Plugin;

use Elementor\Core\Documents_Manager;
use Inti\Elementor\Document\DocumentManager;
use Inti\Wp\Plugin\PluginInterface;
use function add_action;

/**
 * Class RegisterDocuments
 *
 * @package Inti\Elementor\Plugin
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-elementor
 */
final class RegisterDocuments implements PluginInterface
{
    private DocumentManager $manager;
    private array $documents;

    public function __construct(DocumentManager $manager)
    {
        $this->manager = $manager;
    }

    public function run(?array $options = null): void
    {
        $this->documents = $options ?? [];

        if (!empty($this->documents)) {
            add_action('elementor/documents/register', [$this, 'register_documents']);
        }
    }

    public function register_documents(Documents_Manager $manager): void
    {
        foreach ($this->documents as $name) {
            $document = $this->manager->get($name);
            $manager->register_document_type($document->get_name(), $document);
        }
    }
}
